use AdventureWorks2012
go
dbcc traceon(3604)
dbcc traceoff(2301)
dbcc traceon(9481)  -- New ce is better so alot doesent apply
go
dbcc freeproccache
go

-- 2301 - Multiple optimizer enhancements
-- Actual Row count 113,443
-- Join output est 92,115
-- Should be 1 to 1

SELECT th.ProductID, p.ProductID
FROM Production.Product AS p
JOIN Production.TransactionHistory AS th ON
    th.ProductID = p.ProductID
--option(querytraceon 8607,querytraceon 8612)
go

/* The join can be simplified out */
SELECT th.ProductID--,p.ProductID
FROM Production.Product AS p
JOIN Production.TransactionHistory AS th ON
    th.ProductID = p.ProductID
go

--Join output est 107,756
SELECT p.ProductID, th.ProductID
FROM Production.Product AS p
JOIN Production.TransactionHistory AS th ON
    th.ProductID = p.ProductID
option(querytraceon 2301)--,querytraceon 8612,querytraceon 8607)
go


-- 4136 Disable parameter sniffing
Dbcc freeproccache
go
if (object_id('dbo.GetAddress') is not null) begin 
   drop Procedure GetAddress
end
go
create procedure GetAddress @City varchar(30)
as

SELECT addressid
  FROM person.Address 
 where City =  @City
go

exec GetAddress @City = 'Paris'
go

exec GetAddress @City = 'Ottawa'
go

declare @City varchar(30) = 'Paris'

SELECT addressid
  FROM person.Address 
 where City =  @City

go
declare @City varchar(30) = 'Ottawa'

SELECT addressid
  FROM person.Address 
 where City =  @City

 go


Dbcc freeproccache
go

dbcc traceon(4136)
go
exec GetAddress @City = 'Paris'
go

exec GetAddress @City = 'Ottawa'
go

dbcc traceoff(4136)

-- Much more of a blunt instrument than Optimize for



/* TF 2328 - Improve Cardinality Guess */
/* Both these Est @ 106.371 */
select name from Production.Product where len(name) = 50
option(recompile)
go
select * from Production.Product where len(name) = 50
option(recompile)
go

/* Guesses with ISNUMERIC & ISDATE often wrong */
/* Guesses at 1 */
select * from Production.Product where ISNUMERIC(name) = 0
option(recompile)
go

select * from Production.Product where ISNUMERIC(name) = 1
option(recompile)
go

/* Correct Guess , cols selected */
select name from Production.Product where ISNUMERIC(name) = 0
option(recompile)
go


/* Resolve the guess , TF 2328 */
select * from Production.Product where ISNUMERIC(name) = 0
option(recompile,querytraceon 2328)


